-- Code shamelessly stolen from MezHelper.
-- version 0.1 - internal alpha - by Sarf

CrowdControlReport_Options = {
};

CrowdControlReport_Setup = {
	effect = nil;
	blameName = nil;
	debug = false;
};

function CrowdControlReport_OnLoad(frame)
	if ( not frame ) then
		frame = getglobal("CrowdControlReport_Frame");
	end
	if ( not frame ) then
		frame = CreateFrame("Frame", "CrowdControlReport_Frame");
	end
	local _, class = UnitClass("player");
	local ccSpell = CROWDCONTROLREPORT_SPELL[class];
	if ( ccSpell ) then
		if ( type(ccSpell) ~= "table" ) then
			CrowdControlReport_Setup.effect = ccSpell;
			CrowdControlReport_Setup.ccBreak = CrowdControlReport_CreateBreakPattern(ccSpell);
			CrowdControlReport_Setup.ccFade = CrowdControlReport_CreateFadePattern(ccSpell);
			CrowdControlReport_Setup.ccCast = CrowdControlReport_CreateCastPattern(ccSpell);
			CrowdControlReport_Setup.ccPetCast = CrowdControlReport_CreatePetCastPattern(ccSpell);
		elseif ( type(ccSpell) == "table" ) then
			CrowdControlReport_Setup.effects = ccSpell;
			CrowdControlReport_Setup.ccBreak = CrowdControlReport_CreatePatterns(ccSpell, CrowdControlReport_CreateBreakPattern);
			CrowdControlReport_Setup.ccFade = CrowdControlReport_CreatePatterns(ccSpell, CrowdControlReport_CreateFadePattern);
			CrowdControlReport_Setup.ccCast = CrowdControlReport_CreatePatterns(ccSpell, CrowdControlReport_CreateCastPattern);
			CrowdControlReport_Setup.ccPetCast = CrowdControlReport_CreatePatterns(ccSpell, CrowdControlReport_CreatePetCastPatterns);
		end

		frame:SetScript("OnEvent", CrowdControlReport_OnEvent);
		for k, v in CROWDCONTROLREPORT_EVENTS do
			frame:RegisterEvent(v);
		end
		frame:RegisterEvent("VARIABLES_LOADED");
	else
		for k, v in CROWDCONTROLREPORT_EVENTS do
			frame:UnregisterEvent(v);
		end
		CrowdControlReport_Print(CROWDCONTROLREPORT_MSG_PREFIX..CROWDCONTROLREPORT_MSG_WRONG_CLASS);
	end
end

function CrowdControlReport_FindFirst(searchString, match)
	if ( type(match) == "table" ) then
		local tmp;
		for k, v in match do
			tmp = CrowdControlReport_FindFirst(searchString, v);
			if ( tmp ) then return tmp; end
		end
		return nil;
	else
		local _,_,target=string.find(searchString, match);
		return target;
	end
end

function CrowdControlReport_OnEvent()
	if ( event == "VARIABLES_LOADED" ) then
		CrowdControlReport_OnVariablesLoaded();
		return;
	end
--these events fire before BREAK_AURA, so we need to store off the blameTarget
	local mob = CrowdControlReport_Setup.ccTarget;
	if (event == "CHAT_MSG_COMBAT_SELF_HITS" or event == "CHAT_MSG_COMBAT_PARTY_HITS" or event == "CHAT_MSG_COMBAT_FRIENDLYPLAYER_HITS" or event == "CHAT_MSG_COMBAT_PET_HITS") then
		if ( mob ) and ( string.find(arg1, mob) ) then
			CrowdControlReport_Setup.blameName = nil; --each time we enter a hit event we need to refresh the blameTarget
			local blame = nil;
			if (string.find(arg1, CROWDCONTROLREPORT_PATTERN_YOUR_DAMAGE)) then --as in "Your Shadow Bolts hits blah blah"
				blame = UnitName("player");
			end
			if (blame == nil) then
				_, _, blame = string.find(arg1,CROWDCONTROLREPORT_PATTERN_SOMEONE_HIT); --as in "Narnar hits blah blah"
			end
			if (blame == nil) then
				_, _, blame = string.find(arg1,CROWDCONTROLREPORT_PATTERN_SOMEONE_CRIT); --as in "Ichi crits blah blah"
			end
			if (blame ~= nil) then
				CrowdControlReport_Setup.blameName = blame;
				CrowdControlReport_Setup.blameEvidence = arg1;
				CrowdControlReport_Setup.broken = true;
			end
		end
		return;
	end

	if (event == "CHAT_MSG_SPELL_BREAK_AURA") then
		if ( mob ) then
			local _, _, target = CrowdControlReport_FindFirst(arg1, CrowdControlReport_Setup.ccBreak);
			if (target == mob) then
				CrowdControlReport_MezBroken();
				return;
			end
		end
		return;
	end
	if (event == "CHAT_MSG_SPELL_PET_DAMAGE") then
		local _, _, target = CrowdControlReport_FindFirst(arg1, CrowdControlReport_Setup.ccPetCast);
		if (target == UnitName("pet")) then
			CrowdControlReport_MezStarted(UnitName("pettarget"));
		end
		if (target ~= nil) then --if it is nil then this is not a seduction cast and we want to fall through to the last case
			return;
		end
	end

	if (event == "CHAT_MSG_SPELL_SELF_DAMAGE") then
		local _, _, target = CrowdControlReport_FindFirst(arg1, CrowdControlReport_Setup.ccCast);
		if (target ~= nil) then
			CrowdControlReport_MezStarted(target);
			return;
		end
	end

	if (event == "CHAT_MSG_SPELL_AURA_GONE_OTHER") then
		local _, _, target = CrowdControlReport_FindFirst(arg1, CrowdControlReport_Setup.ccFade);
		if (mob) and (target == mob) then
			CrowdControlReport_MezFade();
			return;
		end
		return;
	end

	if (event == "CHAT_MSG_COMBAT_HOSTILE_DEATH") then
		local _, _, target = string.find(arg1, CROWDCONTROLREPORT_PATTERN_SOMEONE_DIED);
		if (mob) and (target == mob) then
			CrowdControlReport_MezDied();
		end
		return;
	end

	if (event ~= nil) then --all that's left are the DAMAGE events, they fire after BREAK_AURA
		if (mob) and ( strfind(arg1, mob) ) then
			local blame = nil;
			wasAMove = 0;
			if (blameTarget == nil) then 
				if ( string.find(arg1, CROWDCONTROLREPORT_PATTERN_YOUR_DAMAGE) ) then --as in "Your Shadow Bolts hits blah blah"
					blame = UnitName("player");
				end
			end
			if (blame == nil) then
				_, _, mobName, blame = string.find(arg1, CROWDCONTROLREPORT_PATTERN_DAMAGE_FROM); -- as in "blah blah takes 120 shadow damage from Angmaro"
				if ( mobName ~= mob ) then
					blame = nil;
				end
			end
			if (blame == nil) then
				_, _, blame = string.find(arg1, ".+ is afflicted by (.+)%.$"); --as in "Dark Iron Dwarf is afflicted by Gouge"
				if (blame ~= nil) then
					wasAMove = 1;
				end
			end
			if (blame ~= nil) then
				CrowdControlReport_Setup.blameName = blame;
				CrowdControlReport_Setup.blameEvidence = arg1;
				CrowdControlReport_Setup.broken = true;
			elseif (CrowdControlReport_Setup.debug) then
				DEFAULT_CHAT_FRAME:AddMessage("MezHelper can't tell who did it. Debug info:");
				DEFAULT_CHAT_FRAME:AddMessage(event);
				DEFAULT_CHAT_FRAME:AddMessage(arg1);
			end
		end
	end
end

function CrowdControlReport_MezStarted(ccTarget)
	CrowdControlReport_MezReset();
	CrowdControlReport_Setup.ccTarget = ccTarget;
end

function CrowdControlReport_MezDied()
	CrowdControlReport_MezReset();
end

function CrowdControlReport_MezBroken()
	if ( CrowdControlReport_Setup.broken ) then
		CrowdControlReport_AnnounceBreaker();
	end
	CrowdControlReport_MezReset();
end

function CrowdControlReport_MezFade()
	if ( CrowdControlReport_Setup.broken ) then
		CrowdControlReport_AnnounceBreaker();
	else
		CrowdControlReport_AnnounceFade();
	end
	CrowdControlReport_MezReset();
end

function CrowdControlReport_MezReset()
	CrowdControlReport_Setup.broken = false;
	CrowdControlReport_Setup.blameName = nil;
	CrowdControlReport_Setup.ccTarget = nil;
end

function CrowdControlReport_GetEffect()
	local effect = CrowdControlReport_Setup.effect;
	if ( not effect ) and ( CrowdControlReport_Setup.effects ) then
		effect = CrowdControlReport_Setup.effects[1];
	end
	return effect;
end

function CrowdControlReport_GetBreakerOtherMember(unit)
	if ( type(CT_RATarget) == "table" ) and ( type(CT_RATarget.MainTanks) == "table" ) then
		for k, v in pairs(CT_RATarget.MainTanks) do
			if ( unit == "raid" .. ( v[1] or "" ) ) then
				return false;
			end
		end
	end
	if ( strfind(unit, "pet") ) then
		local owner = strsub(unit, 1, strlen(unit)-3);
		return format(CROWDCONTROLREPORT_MSG_BLAME_MEMBER_PET, UnitName(owner), CrowdControlReport_GetEffect());
	else
		return format(CROWDCONTROLREPORT_MSG_BLAME_MEMBER, unit, CrowdControlReport_GetEffect());
	end
end

function CrowdControlReport_AnnounceFade()
	local msg = format(CROWDCONTROLREPORT_MSG_FADE, CrowdControlReport_GetEffect(), CrowdControlReport_Setup.ccTarget);
	if ( CrowdControlReport_Options.reportFade ) then
		CrowdControlReport_Print(CROWDCONTROLREPORT_MSG_PREFIX..msg);
	end
	if ( CrowdControlReport_Options.playSoundOnFade ) and ( CrowdControlReport_Options.soundFileOnFade ) then
		PlaySoundFile(CrowdControlReport_Options.soundFileOnFade);
	end
	if ( CrowdControlReport_Options.reportFadeToOthers ) then
		CrowdControlReport_Send(msg);
	end
end

function CrowdControlReport_AnnounceBreaker()
	local whoToBlame = CrowdControlReport_Setup.blameName;
	if ( not whoToBlame ) then
		CrowdControlReport_Print(CROWDCONTROLREPORT_MSG_PREFIX..CROWDCONTROLREPORT_MSG_NO_ONE_TO_BLAME);
		return;
	end
	local msg = nil;
	if ( UnitName("player") == whoToBlame ) then
		msg = format(CROWDCONTROLREPORT_MSG_BLAME_SELF, CrowdControlReport_GetEffect());
	elseif ( UnitName("pet") == whoToBlame ) then
		msg = format(CROWDCONTROLREPORT_MSG_BLAME_SELF_PET, CrowdControlReport_GetEffect());
	end
	if ( not msg ) then
		local raiders = GetNumRaidMembers();
		if ( raiders > 0 ) then
			local number = raiders;
			local unit = nil;
			local class = nil;
			for i = 1, number do
				unit = CROWDCONTROLREPORT_RAID_UNITS[i];
				if ( UnitName(unit) == whoToBlame ) then
					_, class = UnitClass(unit);
					if ( class ~= "WARRIOR" ) or ( CrowdControlReport_Options.reportWarriorInRaid ) then
						msg = CrowdControlReport_GetBreakerOtherMember(unit);
					else
						msg = false;
					end
					break;
				end
			end
			if ( msg == nil ) then
				for i = 1, number do
					unit = CROWDCONTROLREPORT_RAID_UNITS[40+i];
					if ( UnitName(unit) == whoToBlame ) then
						msg = CrowdControlReport_GetBreakerOtherMember(unit);
						break;
					end
				end
			end
		else
			local partyMembers = GetNumPartyMembers();
			local unit = nil;
			local class = nil;
			for i = 1, partyMembers do
				unit = CROWDCONTROLREPORT_PARTY_UNITS[i];
				if ( UnitName(unit) == whoToBlame ) then
					_, class = UnitClass(unit);
					if ( class ~= "WARRIOR" ) or ( CrowdControlReport_Options.reportWarriorInParty ) then
						msg = CrowdControlReport_GetBreakerOtherMember(unit);
					else
						msg = false;
					end
					break;
				end
			end
			if ( msg == nil ) then
				for i = 1, partyMembers do
					unit = CROWDCONTROLREPORT_PARTY_UNITS[40+i];
					if ( UnitName(unit) == whoToBlame ) then
						msg = CrowdControlReport_GetBreakerOtherMember(unit);
						break;
					end
				end
			end
		end
	end
	if ( msg == false ) then
		-- Handles breaking from main tank.
		return;
	end
	if ( CrowdControlReport_Options.playSoundOnBreak ) and ( CrowdControlReport_Options.soundFileOnBreak ) then
		PlaySoundFile(CrowdControlReport_Options.soundFileOnBreak);
	end
	if ( CrowdControlReport_Options.reportToSelf ) then
		if ( CrowdControlReport_Options.reportToSelfEvidence ) and ( CrowdControlReport_Setup.blameEvidence ) then
			CrowdControlReport_Print(CROWDCONTROLREPORT_MSG_PREFIX..msg.."\n"..CrowdControlReport_Setup.blameEvidence);
		else
			CrowdControlReport_Print(CROWDCONTROLREPORT_MSG_PREFIX..msg);
		end
	end
	if ( CrowdControlReport_Options.reportToOthers ) and 
		( ( ( UnitName("player") ~= whoToBlame ) and 
		( UnitName("pet") ~= whoToBlame ) ) 
		or ( CrowdControlReport_Options.reportSelfToOthers ) 
		) then
		CrowdControlReport_Send(msg);
	end
end

function CrowdControlReport_Send(msg)
	local channel = "SAY";
	if ( GetNumRaidMembers() > 0 ) then
		channel = "RAID";
	elseif ( GetNumPartyMembers() > 0 ) then
		channel = "PARTY";
	end
	SendChatMessage(msg, channel);
end

function CrowdControlReport_Print(msg)
	ChatFrame1:AddMessage(msg, 1, 1, 0);
	local frame;
	for i = 2, 9 do
		frame = getglobal("ChatFrame"..i);
		if ( frame ) and ( frame:IsVisible() ) then
			frame:AddMessage(msg, 1, 1, 0);
		end
	end
end

function CrowdControlReport_OnVariablesLoaded()
	for k, v in CROWDCONTROLREPORT_OPTIONS_DEFAULT do
		if ( CrowdControlReport_Options[k] == nil ) then
			CrowdControlReport_Options[k] = v;
		end
	end
end

function CrowdControlReport_CreatePatterns(list, func)
	local t = {};
	for k, v in list do
		table.insert(t, func(v));
	end
	return t;
end

function CrowdControlReport_SlashCommand(msg)
	-- TODO.
end

CrowdControlReport_OnLoad();
